"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _catalog = require("../lib/catalog");

var _catalog2 = _interopRequireDefault(_catalog);

var _catalogContext = require("./catalog-context");

var _catalogContext2 = _interopRequireDefault(_catalogContext);

var _useCatalog = require("./use-catalog");

var _useCatalog2 = _interopRequireDefault(_useCatalog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CatalogProvider = function CatalogProvider(props) {
  var _props$catalog = props.catalog,
      catalog = _props$catalog === void 0 ? {} : _props$catalog,
      children = props.children;

  var _ref = (0, _useCatalog2.default)() || {},
      outerCatalog = _ref.catalog;

  var prepCatalog = catalog;

  if (outerCatalog) {
    prepCatalog = new _catalog2.default({
      components: _objectSpread({}, outerCatalog && outerCatalog._components, catalog && catalog._components)
    });
  }

  return _react2.default.createElement(_catalogContext2.default.Provider, {
    value: {
      catalog: prepCatalog
    }
  }, _react2.default.Children.only(children));
};

exports.default = CatalogProvider;