"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withCatalog = exports.getDisplayName = undefined;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require("hoist-non-react-statics");

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _useCatalog = require("./use-catalog");

var _useCatalog2 = _interopRequireDefault(_useCatalog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var getDisplayName = exports.getDisplayName = function getDisplayName(Component) {
  return Component.displayName || Component.name || 'Component';
};

var withCatalog = exports.withCatalog = function withCatalog(Component) {
  var WithCatalog = function WithCatalog(props) {
    var catalog = (0, _useCatalog2.default)();
    return _react2.default.createElement(Component, _extends({}, props, {
      catalog: catalog && catalog.catalog
    }));
  };

  WithCatalog.displayName = "WithCatalog(".concat(getDisplayName(Component), ")");
  (0, _hoistNonReactStatics2.default)(WithCatalog, Component);
  return WithCatalog;
};

exports.default = withCatalog;